rexxHandler=.RexxAppHandler~new
rxApp=BSFCreateRexxProxy(rexxHandler, ,"javafx.application.Application")
rxApp~launch(rxApp~getClass, .nil)

::requires "BSF.CLS"
::requires UNO.CLS
::class RexxAppHandler
::method start
use arg primaryStage
 primaryStage~setTitle("XML File Parser")
 colorClz=bsf.loadClass("javafx.scene.paint.Color")
 cdClz=bsf.loadClass("javafx.scene.control.ContentDisplay")
 alClz=bsf.loadClass("javafx.geometry.Pos")
 root=.bsf~new("javafx.scene.layout.AnchorPane")
 root~prefHeight=200
 root~prefWidth=430
 root~setStyle("-fx-background-color: linear-gradient(to right, #590063 , #280063)")

input_data = .array ~NEW

-- Creating Buttons

 

    b_enter=.bsf~new("javafx.scene.control.Label") 
        b_enter~setLayoutX(20)
        b_enter~setLayoutY(200)
        b_enter~setPrefHeight(40)
        b_enter~setPrefWidth(380)
        b_enter~setVisible("true")
        b_enter~setTextFill(colorClz~Blue)
        b_enter~setText("Click parse to get Output in Terminal")

        b_enter~setVisible("true")
        b_enter~setStyle("-fx-font-size: 16.8;-fx-text-fill: white;-fx-background-color: rgba(255, 255, 255, .1);-fx-background-radius: 3")

    b_parse=.bsf~new("javafx.scene.control.Button")
        b_parse~setTextFill(colorClz~BLACK)
        b_parse~setLayoutX(280)
        b_parse~setLayoutY(280)
        b_parse~setPrefHeight(60)
        b_parse~setPrefWidth(60)
        b_parse~setText("Parse")f
        b_parse~setVisible("true")
        b_parse~setStyle("-fx-font-weight: BOLD;-fx-font-size: 15;-fx-text-fill: white;-fx-background-color: rgba(255, 255, 255,.1);-fx-background-radius: 30")


    b_text=.bsf~new("javafx.scene.control.TextField")
        b_text~setLayoutX(20)
        b_text~setLayoutY(65)
        b_text~setPrefHeight(40)
        b_text~setPrefWidth(380)
        b_text~setPromptText("enter XML Filepath")
        b_text~setVisible("true")
        b_text~setStyle("-fx-font-size: 15;-fx-text-fill: white;-fx-background-color: rgba(255, 255, 255,.1);-fx-background-radius: 3")
		
		
	s_text=.bsf~new("javafx.scene.control.Label")
        s_text~setLayoutX(20)
        s_text~setLayoutY(125)
        s_text~setPrefHeight(40)
        s_text~setPrefWidth(380)
        s_text~setText("Thanks for using the XML Parser")
        s_text~setVisible("false")
        s_text~setStyle("-fx-font-size: 15;-fx-text-fill: white;-fx-background-color: rgba(255, 255, 255,.1);-fx-background-radius: 3")

root~getChildren~add(b_enter)
root~getChildren~add(b_parse)
root~getChildren~add(b_text)
root~getChildren~add(s_text)

scene=.bsf~new("javafx.scene.Scene", root)
primaryStage~setScene(scene)
primaryStage~show

--Handler Parse
    handler_b_parse=BSFCreateRexxProxy(.RexxButton_b_parse_Handler~new(b_text , b_parse , b_enter, s_text), ,"javafx.event.EventHandler")
    b_parse~setOnAction(handler_b_parse)


--:: class for Parse


    ::class RexxButton_b_parse_Handler
      ::method init
           expose b_text b_parse b_enter s_text
           use arg b_text , b_parse , b_enter, s_text
      ::method handle
           expose b_text b_parse b_enter s_text
           b_text~setVisible("false")
           b_parse~setVisible("false")
		   b_enter~setVisible("false")
		   s_text~setVisible("true")
        
           name = strip(b_text~getText)
		   
		   say name
		
			parse arg 
			rexxObject=.saxHandler~new
			rexxProxy =BsfCreateRexxProxy(rexxObject)
			objArray=bsf.createArray(bsf.loadClass("java.lang.Object"), 1)
			objArray[1]="org.xml.sax.ContentHandler"     
			javaProxy =rexxProxy~newJavaProxyInstance(objArray)
			parser=bsf.loadClass("org.xml.sax.helpers.XMLReaderFactory")~createXMLReader
			parser~setContentHandler(javaProxy)
			eh=.errorHandler~new
			javaEH=BsfCreateRexxProxy(eh, , "org.xml.sax.ErrorHandler")
			parser~setErrorHandler(javaEH)
			parser~parse(name)
			::requires BSF.CLS      
			::class "saxHandler" 
			::method init
			 expose book_num
			 book_num = 0
			 
			 ::method startElement
			 expose book_num
			 use arg , localName
			  if localName = "title" then
				book_num +=1
				say localName " of the " book_num "th Book"
				
 
			::method characters     
			  use arg textCharArray, start, length
			  say pp(.bsf~new("java.lang.String", textCharArray, start, length)~toString)
			::method unknown        
			::class ErrorHandler    
			::method warning        
			  use arg exc
			  .error~say("warning:    "  "line="exc~getLineNumber",col="exc~getColumnNumber":" pp(exc~getMessage))
			::method error                                        
			  use arg exc
			  .error~say("error:      "  "line="exc~getLineNumber",col="exc~getColumnNumber":" pp(exc~getMessage))
			::method fatalError     
			  use arg exc
			  .error~say("FATAL error:"  "line="exc~getLineNumber",col="exc~getColumnNumber":" pp(exc~getMessage))
			
	
			say parsed_data
			return parsed_data
			
				
			 



